#!/usr/bin/env python

from simple_at import *
from pyatspi import StateSet

def run(acc):
  print "[start]"

  col = acc.queryInterface('IDL:Accessibility/Collection:1.0')
  if col is None:
    raise NotImplementedError('%s does not implement collection' % acc.name)

  print "[Collection]"
  
  roles = [Accessibility.ROLE_PUSH_BUTTON]
  states = StateSet()
  
  states.add(Accessibility.STATE_SHOWING)

  print states.isEmpty()
  print "Roles to match:", roles  
  print "States to match:", states.raw().getStates()
  
  rule = col.createMatchRule(states.raw(), col.MATCH_ALL,  
                             "", col.MATCH_ALL,
                             roles, col.MATCH_ANY,
                             "", col.MATCH_ALL,
                             False)

  print "[getMatches]"

  sort =  col.SORT_ORDER_CANONICAL
  #sort =  col.SORT_ORDER_REVERSE_CANONICAL
  
  ls = col.getMatches (rule, sort, 0)

  print "all buttons shown on screen"
  
  for n in ls: 
    print n.name

  print "return only the first 5 buttons shown on screen"

  lsn = col.getMatches (rule, sort, 10) #only 5 matches

  for n in lsn: 
    print n.name
  
#  col.freeMatchRule (rule)

  obj = lsn[9] # try to search starting from this object

  print "use this object as reference for getMatches[From/To]", obj

  print "[getMatchesFrom]"

#  rsort =  col.SORT_ORDER_REVERSE_CANONICAL

  lsf = col.getMatchesFrom (obj, rule, sort, False, 0)

#  print rule, lsf

  for n in lsf: 
    print n.name

  print "[getMatchesTo]"

  lst = col.getMatchesTo (obj, rule, sort, True, 0)
  for n in lst: 
    print n.name

    
  return 1

if __name__ == '__main__':
  d = registry.getDesktop(0)
  for i in xrange(d.childCount):
    try:
      c = d.getChildAtIndex(i)
    except:
      continue
    if c is not None and c.name == 'gcalctool':
      run(c)

print "[fin]"
